/*************************************************
FOX 2 SX16base

Esempio di collegamento tra FOX e SX16 ver BASE.
Lettura degli stati dei 24 ingressi




Collegamenti elettrici:
  OG5 (pin 22 FOX) --> IPL (Pin 5 SX16)
  IG1 (pin 24 FOX) --> IDA (Pin 4 SX16)
  OG3 (pin 26 FOX) --> ICL (Pin 3 SX16)
  VCC +5V (pin 12 FOX )  --  VCC (Pin 9 SX16) 
  GND (pin 40 FOX )  --  GND (Pin 10 SX16)
****************************************************/

#include "stdio.h"     
#include "unistd.h"    
#include "sys/ioctl.h"
#include "fcntl.h"     
#include "time.h"     
#include "asm/etraxgpio.h"
#include "stdlib.h"

#define OG5  1<<5
#define OG3  1<<3
#define IG1  1<<1

#define CLOCK       ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_CLRBITS),OG3);ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_SETBITS),OG3);
#define STROBE      ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_CLRBITS),OG5);ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_SETBITS),OG5);


#ifndef IO_SETGET_INPUT
  #define IO_SETGET_INPUT   0x12
#endif

#ifndef IO_SETGET_OUTPUT
  #define IO_SETGET_OUTPUT  0x13
#endif

int main(void) {
  int fdg;
  int iomask_g;
  int i;
  int value;


  if ((fdg = open("/dev/gpiog", O_RDWR))<0) {
    printf("ERRORE di apertura del device /dev/gpiog\n");
    return 1;
  }

  // Set all the availables IOG lines on port G as output
  iomask_g = OG5 | OG3;
  ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_SETGET_OUTPUT),&iomask_g);
  ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_CLRBITS),iomask_g); //Tutte le linee a OFF
  iomask_g = IG1;
  ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_SETGET_INPUT),&iomask_g);

  while(1) {
   system("clear");
   printf("---------------------------------------\n");
   printf(" FOX 2 SX16base\n\n");
   printf(" Ver: 1.0\n");
   printf(" Author: Daniele De Santis\n");
   printf(" E-Mail: desantis@areasx.it\n\n");
   printf(" STATO DELLE LINEE D'INPUT SULLA SX 16 \n");
   printf("---------------------------------------\n");
    STROBE
    for (i=0;i<24;i++) {
      value=ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_READBITS));
      if (i>=0 && i<=7) {
        if ((value&(IG1))==0) {
          printf("LINEA OPTO %d [X]\n", (8-i));
        } else {
          printf("LINEA OPTO %d [ ]\n", (8-i));
        }
      } else if (i>=8 && i<=15) {
        if ((value&(IG1))==0) {
          printf("LINEA TTL  %d [X]\n", (16-i));
        } else {
          printf("LINEA TTL  %d [ ]\n", (16-i));
        }
      } else if (i>=16 && i<=23) {
        if ((value&(IG1))==0) {
          printf("LINEA RC   %d [X]\n", (24-i));
        } else {
          printf("LINEA RC   %d [ ]\n", (24-i));
        }
      }
      CLOCK
    }
    sleep(5);
    
  }
  close(fdg);
  return 0;
}
