/*************************************************
FOX 2 SX16base

Esempio di collegamento tra FOX e SX16 ver BASE.
Gestione dei 6 rel presenti sulla SX16




Collegamenti elettrici:
  OG1 (pin 23 FOX) --> OCL (Pin 6 SX16)
  OG2 (pin 21 FOX) --> ODA (Pin 8 SX16)
  OG4 (pin 25 FOX) --> STR (Pin 7 SX16)
  VCC +5V (pin 12 FOX )  --  VCC (Pin 9 SX16) 
  GND (pin 40 FOX )  --  GND (Pin 10 SX16)
****************************************************/

#include "stdlib.h"
#include "stdio.h"     
#include "unistd.h"    
#include "sys/ioctl.h"
#include "fcntl.h"     
#include "time.h"     
#include "asm/etraxgpio.h"

#define OG1  1<<1
#define OG2  1<<2
#define OG3  1<<3
#define OG4  1<<4

#define CLOCK       ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_SETBITS),OG1);ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_CLRBITS),OG1);
#define STROBE      ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_SETBITS),OG4);ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_CLRBITS),OG4);
#define SET_DATA    ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_SETBITS),OG2);
#define CLEAR_DATA  ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_CLRBITS),OG2);

#define IO_SETGET_OUTPUT  0x13


int read_key(){
    char _buff[4];
    int _ch;
    int _char_count;
    
    _ch = getchar();
    _char_count = 0;
    while((_ch != 10)  &&  (_char_count < 3)) {
      _buff[_char_count++] = _ch;
      _ch = getchar();
    }
    _buff[_char_count] = 0x00;      
    return atoi(_buff);
    
    
}




int main(void) {
  int fdg;
  int iomask_g;
  int i;
  int outstatus;
  

  if ((fdg = open("/dev/gpiog", O_RDWR))<0) {
    printf("Open error on /dev/gpiog\n");
    return 1;
  }

  // Set all the availables IOG lines on port G as output
  iomask_g = OG1 | OG2 | OG4;
  ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_SETGET_OUTPUT),&iomask_g);
  ioctl(fdg, _IO(ETRAXGPIO_IOCTYPE, IO_CLRBITS),iomask_g); //Tutte le linee a OFF
  
  while(1) {
   system("clear");
   printf("---------------------------------------\n");
   printf(" FOX 2 SX16base\n\n");
   printf(" Ver: 1.0\n");
   printf(" Author: Daniele De Santis\n");
   printf(" E-Mail: desantis@areasx.com\n\n");
   printf(" COMANDARE I RELE' SULLA SX 16 \n");
   printf("---------------------------------------\n");
   printf("Valore decimale per comandare i rele' [da 0 a 63]\n");
   outstatus = read_key();
   printf("%d\n", outstatus);
  for (i=7;i>=0;i--) {
    if (outstatus & (0x01<<i) ) {
      SET_DATA;
    } else {
      CLEAR_DATA;
    }
    CLOCK;
  }
  
  STROBE;
  }
  close(fdg);
  return 0;
}
